/*
 *	A simple WAP support library
 *	(c) 2001 Alan Cox <alan@lxorguk.ukuu.org.uk>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Due to patent restrictions on WAP in the USA this software is not licensed
 *  for use within the United States of America, its dependancies, embassies
 *  or other jurisdictions
 */
 
#include <stdio.h>
#include "libwap.h"

/*
 *	WAP libraries
 */
 
void wml_header(int cachetime)
{
	printf("<?xml version=\"1.0\"?>\r\n");
	printf("<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\"\r\n");
	printf(" \"http://www.wapforum.org/DTD/wml_1.1.xml\">\r\n");
	printf("<wml>\r\n");
	if(cachetime!=-1)
		printf("<head><meta http-equiv=\"Cache-Control\" content=\"max-age=%d\"/></head>\r\n", cachetime);
}

void wml_footer(void)
{
	printf("</wml>\r\n");
}

void wml_link(char *title, char *url, char *txt)
{
	printf("<a title=\"%s\" href=\"%s\">%s</a><br/>\r\n",
		title,url, txt);
}

void wml_do(char *type, char *label, char *url)
{
	printf("<do type=\"%s\" label=\"%s\">\r\n", type,label);
	printf("<go href=\"%s\"/>\r\n", url);
	printf("</do>\r\n");
}

void wml_br(void)
{
	printf("<br/>\r\n");
}


void wml_back(void)
{
	printf("<do type=\"prev\" label=\"Back\"><prev/></do>\r\n");
}
