/*
 *	WAP client cgi
 *	(c) 2001 Alan Cox <alan@lxorguk.ukuu.org.uk>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Due to patent restrictions on WAP in the USA this software is not licensed
 *  for use within the United States of America, its dependancies, embassies
 *  or other jurisdictions
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <ctype.h>
#include <signal.h>
#include <time.h>
#include <sys/socket.h>
#include <sys/un.h>

#include "config.h"
#include "cgi.h"
#include "libwap.h"

static void write_wml(char *p)
{
	while(*p)
	{
		if(*p=='<')
			printf("&lt;");
		else if(*p=='>')
			printf("&gt;");
		else if(*p=='%')
			printf("&prcnt;");
		else if(*p=='&')
			printf("&amp;");
		else if(*p=='\n')
			printf("<br/>\n");
		else
			printf("%c", *p);
		p++;
	}
}

static void write_card(int fd)
{
	char *x;
	char buf[256];
	int l;
		
	wml_header(-1);
		
	x=cgi_find("command");
	if(x && *x)
	{
		snprintf(buf, sizeof(buf), ">%s\n", x);
		if(write(fd, buf, 255)!=255)
		{
			wml_back();
			printf("<card><p>Write failed (I/O error).</p></card>\n");
			wml_footer();
			exit(1);
		}
	}
	else
	{
		sprintf(buf, "<");
		if(write(fd, buf, 255)!=255)
		{
			wml_back();
			printf("<card><p>Write failed (I/O error).</p></card>\n");
			wml_footer();
			exit(1);
		}
	}
	printf("<card newcontext=\"true\">\n");
//	printf("<onevent eventype=\"onenterforward\" href=\"/subs.wmls#fixvar('command')\"/>\n");
	printf("<setvar name=\"command\" value=\"\"/>\n");
	printf("<p>\n");
	while((l=read(fd,buf,512))>0)
	{
		buf[l]=0;
		write_wml(buf);
		fflush(stdout);
	}
	printf("</p>\n");
	printf("<p>Say: <input type=\"text\" name=\"command\" value=\"\" default=\"\" format=\"*M\"/></p>\n");
	printf("<p><anchor>Go\n");
	printf("<go method=\"get\"WAPIRC_URL\">\n");
	printf("<postfield name=\"command\" value=\"$(command)\"/>\n");
	printf("<postfield name=\"id\" value=\"%d%ld\"/>\n", (int)getpid(), (long)time(NULL));
//	printf("<var name=\"command\" value=\"\"/>\n");
	printf("</go></anchor></p>\n");
	snprintf(buf, sizeof(buf),WAPIRC_URL"?id=%d%ld", 
		(int)getpid(), (long)time(NULL));
	wml_link("More", buf, "More..");
	printf("</card>\n");
	wml_footer();
	exit(0);
}

int main(int argc, char *argv[])
{
	int fd=socket(PF_UNIX, SOCK_STREAM, 0);
	struct sockaddr_un sun;

	printf("Content-type: text/vnd.wap.wml\r\n");
	printf("Pragma: nocache\r\n");
	printf("Cache-Control: no-cache, must-revalidate\r\n");
	printf("\r\n");
	cgi_process();
	sun.sun_family=AF_UNIX;
	snprintf(sun.sun_path, sizeof(sun.sun_path), WAPIRC_SOCKPATH);
	
	if(connect(fd, (struct sockaddr *)&sun, sizeof(sun))==-1)
	{
		wml_header(-1);
		wml_back();
		printf("<card><p>Connection failed - wircd down ?</p></card>\n");
		wml_footer();
		exit(1);
	}
			
	write_card(fd);
	close(fd);
	return 0;
}
